(in-package "UNIFY")

(defmacro pattern-case (form vars &rest clauses)
  (labels ((subst-vars (vars clauses-tests)
             (if vars
                 (etypecase (first vars)
                   (symbol
                    (subst-vars (rest vars) (subst (make-logical-var (first vars))
                                                   (first vars)
                                                   clauses-tests)))
                   (cons
                    (subst-vars (rest vars) (subst (make-logical-var (first vars))
                                                   (caar vars)
                                                   clauses-tests))))
               clauses-tests))
           )

    (let ((new-clauses (mapcar 'cons
                               (subst-vars vars (mapcar #'first clauses))
                               (mapcar #'rest clauses))))
      `(match-case (,form) ,@new-clauses))))




(defun make-logical-var (x)
  (flet ((logvar (x)
           (intern (concatenate 'string "?" (symbol-name x))
                   (symbol-package x)))
         )
    (etypecase x
      (symbol (logvar x))
      (cons (destructuring-bind (var type)
                x
              (make-template type (list type (logvar var))))))))


#|
(pattern-case form ((n integer))
              ((+ n 0) n)
              ((x n 0) 0)
              ((x n 1) 1))
|#